Skip to content
Changelog

Report a bug

Grafana integration: operations for AI agents

Grafana connects to Type.com as an integration. This page lists the 250 operations documented for Claude and Codex in Type.com: 115 read, 74 write, 61 destructive.

About Grafana

Open and composable observability platform for metrics, logs, and traces

Categories: Developer Tools & IT

How to connect Grafana to Type.com

Access
Organization connection: one shared account for the workspace.

To add the connection, follow the steps in Space connections.

Documented operations

250 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.

250 operations listed.

Access control

  • Read

    Get all roles.

    Gets all existing roles. The response contains all global and organization local roles, for the organization which user is signed in. You need to have a permission with action roles:read and scope roles:.

  • Read

    Get a role.

    Get a role for the given UID. You need to have a permission with action roles:read and scope roles:.

  • Read

    Get role assignments.

    Get role assignments for the role with the given UID. Does not include role assignments mapped through group attribute sync. You need to have a permission with action teams.roles:list and scope teams:id: and users.roles:list and scope users:id:.

  • Read

    Get status.

    Returns an indicator to check if fine-grained access control is enabled or not. You need to have a permission with action status:accesscontrol and scope services:accesscontrol.

  • Read

    List roles assigned to multiple teams.

    Lists the roles that have been directly assigned to the given teams. You need to have a permission with action teams.roles:read and scope teams:id:.

  • Read

    Get team roles.

    You need to have a permission with action teams.roles:read and scope teams:id: .

  • Read

    List roles assigned to multiple users.

    Lists the roles that have been directly assigned to the given users. The list does not include built-in roles (Viewer, Editor, Admin or Grafana Admin), and it does not include roles that have been inherited from a team.

  • Read

    List roles assigned to a user.

    Lists the roles that have been directly assigned to a given user. The list does not include built-in roles (Viewer, Editor, Admin or Grafana Admin), and it does not include roles that have been inherited from a team.

  • Read

    Get a description of a resource's access control properties.

    GET /access-control/{resource}/description

  • Read

    Get permissions for a resource.

    GET /access-control/{resource}/{resourceID}

  • Write

    Create a new custom role.

    Creates a new custom role and maps given permissions to that role. Note that roles with the same prefix as Fixed Roles can’t be created. You need to have a permission with action roles:write and scope permissions:type:delegate.

  • Write

    Add team role.

    You need to have a permission with action teams.roles:add and scope permissions:type:delegate.

  • Write

    Add a user role assignment.

    Assign a role to a specific user. For bulk updates consider Set user role assignments. You need to have a permission with action users.roles:add and scope permissions:type:delegate.

  • Write

    Set resource permissions.

    Assigns permissions for a resource by a given type (:resource) and :resourceID to one or many assignment types. Allowed resources are datasources, teams, dashboards, folders, and serviceaccounts.

  • Write

    Set resource permissions for a built-in role.

    Assigns permissions for a resource by a given type (:resource) and :resourceID to a built-in role. Allowed resources are datasources, teams, dashboards, folders, and serviceaccounts. Refer to the /access-control/{resource}/description endpoint for allowed Permissions.

  • Write

    Set resource permissions for a team.

    Assigns permissions for a resource by a given type (:resource) and :resourceID to a team. Allowed resources are datasources, teams, dashboards, folders, and serviceaccounts. Refer to the /access-control/{resource}/description endpoint for allowed Permissions.

  • Write

    Set resource permissions for a user.

    Assigns permissions for a resource by a given type (:resource) and :resourceID to a user or a service account. Allowed resources are datasources, teams, dashboards, folders, and serviceaccounts. Refer to the /access-control/{resource}/description endpoint for allowed Permissions.

  • Destructive

    Update a custom role.

    You need to have a permission with action roles:write and scope permissions:type:delegate. permissions:type:delegate scope ensures that users can only update custom roles with permissions which the user has.

  • Destructive

    Delete a custom role.

    Delete a role with the given UID, and it’s permissions. If the role is assigned to a built-in role, the deletion operation will fail, unless force query param is set to true, and in that case all assignments will also be deleted.

  • Destructive

    Set role assignments.

    Set role assignments for the role with the given UID. You need to have a permission with action teams.roles:add and teams.roles:remove and scope permissions:type:delegate, and users.roles:add and users.roles:remove and scope permissions:type:delegate.

  • Destructive

    Update team role.

    You need to have a permission with action teams.roles:add and teams.roles:remove and scope permissions:type:delegate for each. The delegate scope is required for permissions on roles being added.

  • Destructive

    Remove team role.

    You need to have a permission with action teams.roles:remove and scope permissions:type:delegate.

  • Destructive

    Set user role assignments.

    Update the user’s role assignments to match the provided set of UIDs. This will remove any assigned roles that aren’t in the request and add roles that are in the set but are not already assigned to the user. Roles mapped through group attribute sync are not impacted.

  • Destructive

    Remove a user role assignment.

    Revoke a role from a user. For bulk updates consider Set user role assignments. You need to have a permission with action users.roles:remove and scope permissions:type:delegate.

Admin ldap

  • Read

    Returns the current state of the LDAP background sync integration.

    You need to have a permission with action ldap.status:read.

  • Read

    Attempts to connect to all the configured LDAP servers and returns information on whenever they're available or not.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action ldap.status:read.

  • Read

    Finds an user based on a username in LDAP. This helps illustrate how would the particular user be mapped in Grafana whe…

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action ldap.user:read.

  • Write

    Reloads the LDAP configuration.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action ldap.config:reload.

  • Write

    Enables a single Grafana user to be synchronized against LDAP.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action ldap.user:sync.

Admin provisioning

  • Write

    You need to have a permission with action provisioning:reload with scope provisioners:accesscontrol.

    You need to have a permission with action provisioning:reload with scope provisioners:accesscontrol.

  • Write

    Reload dashboard provisioning configurations.

    Reloads the provisioning config files for dashboards again. It won’t return until the new provisioned entities are already stored in the database.

  • Write

    Reload datasource provisioning configurations.

    Reloads the provisioning config files for datasources again. It won’t return until the new provisioned entities are already stored in the database.

  • Write

    Reload plugin provisioning configurations.

    Reloads the provisioning config files for plugins again. It won’t return until the new provisioned entities are already stored in the database. In case of dashboards, it will stop polling for changes in dashboard files and then restart it with new configurations after returning.

Admin

  • Read

    Fetch settings.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action settings:read and scopes: settings:, settings:auth.saml: and settings:auth.saml:enabled (property level).

  • Read

    Fetch Grafana Stats.

    Only works with Basic Authentication (username and password). See introduction for an explanation. If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action server:stats:read.

Admin users

  • Read

    Return a list of all auth tokens (devices) that the user currently have logged in from.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.authtoken:list and scope global.users:.

  • Write

    Create new user.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users:create.

  • Write

    Disable user.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users:disable and scope global.users:1 (userIDScope).

  • Write

    Enable user.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users:enable and scope global.users:1 (userIDScope).

  • Write

    Logout user revokes all auth tokens (devices) for the user. User of issued auth tokens (devices) will no longer be logg…

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.logout and scope global.users:.

  • Destructive

    Delete global User.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users:delete and scope global.users:.

  • Destructive

    Set password for user.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.password:update and scope global.users:.

  • Destructive

    Set permissions for user.

    Only works with Basic Authentication (username and password). See introduction for an explanation. If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.permissions:update and scope global.users:.

  • Destructive

    Revoke auth token for user.

    Revokes the given auth token (device) for the user. User of issued auth token (device) will no longer be logged in and will be required to authenticate again upon next activity.

Quota

  • Read

    Fetch user quota.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.quotas:list and scope global.users:1 (userIDScope).

  • Read

    Fetch Organization quota.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action orgs.quotas:read and scope org:id:1 (orgIDScope).

  • Read

    Fetch Organization quota.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action orgs.quotas:read and scope org:id:1 (orgIDScope).

  • Read

    Fetch user quota.

    GET /user/quotas

  • Destructive

    Update user quota.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action users.quotas:update and scope global.users:1 (userIDScope).

  • Destructive

    Update user quota.

    If you are running Grafana Enterprise and have Fine-grained access control enabled, you need to have a permission with action orgs.quotas:write and scope org:id:1 (orgIDScope).

Annotations

  • Read

    Find Annotations.

    Starting in Grafana v6.4 regions annotations are now returned in one entity that now includes the timeEnd property.

  • Read

    Find Annotations Tags.

    Find all the event tags created in the annotations.

  • Read

    Get Annotation by ID.

    GET /annotations/{annotation_id}

  • Write

    Create Annotation.

    Creates an annotation in the Grafana database. The dashboardId and panelId fields are optional. If they are not specified then an organization annotation is created and can be queried in any dashboard that adds the Grafana annotations data source.

  • Write

    Create Annotation in Graphite format.

    Creates an annotation by using Graphite-compatible event format. The when and data fields are optional. If when is not specified then the current time will be used as annotation’s timestamp.

  • Write

    Patch Annotation.

    Updates one or more properties of an annotation that matches the specified ID. This operation currently supports updating of the text, tags, time and timeEnd properties. This is available in Grafana 6.0.0-beta2 and above.

  • Destructive

    Delete multiple annotations.

    POST /annotations/mass-delete

  • Destructive

    Update Annotation.

    Updates all properties of an annotation that matches the specified id. To only update certain property, consider using the Patch Annotation operation.

  • Destructive

    Delete Annotation By ID.

    Deletes the annotation that matches the specified ID.

Devices

  • Read

    Lists all devices within the last 30 days

    GET /anonymous/devices

  • Read

    Lists all devices within the last 30 days

    GET /anonymous/search

Migrations

  • Read

    Get a list of all cloud migration sessions that have been created.

    GET /cloudmigration/migration

  • Read

    Get a cloud migration session by its uid.

    GET /cloudmigration/migration/{uid}

  • Read

    Get metadata about a snapshot, including where it is in its processing and final results.

    GET /cloudmigration/migration/{uid}/snapshot/{snapshotUid}

  • Read

    Get a list of snapshots for a session.

    GET /cloudmigration/migration/{uid}/snapshots

  • Read

    Get the resource dependencies graph for the current set of migratable resources.

    GET /cloudmigration/resources/dependencies

  • Read

    Fetch the cloud migration token if it exists.

    GET /cloudmigration/token

  • Write

    Create a migration session.

    POST /cloudmigration/migration

  • Write

    Trigger the creation of an instance snapshot associated with the provided session.

    If the snapshot initialization is successful, the snapshot uid is returned.

  • Write

    Upload a snapshot to the Grafana Migration Service for processing.

    POST /cloudmigration/migration/{uid}/snapshot/{snapshotUid}/upload

  • Write

    Create gcom access token.

    POST /cloudmigration/token

  • Destructive

    Delete a migration session by its uid.

    DELETE /cloudmigration/migration/{uid}

  • Destructive

    Cancel a snapshot, wherever it is in its processing chain.

    TODO: Implement

  • Destructive

    Deletes a cloud migration token.

    DELETE /cloudmigration/token/{uid}

Convert prometheus

  • Read

    Gets all Grafana-managed alert rules that were imported from Prometheus-compatible sources, grouped by namespace.

    GET /convert/api/prom/rules

  • Read

    Gets Grafana-managed alert rules that were imported from Prometheus-compatible sources for a specified namespace (folde…

    Gets Grafana-managed alert rules that were imported from Prometheus-compatible sources for a specified namespace (folder).

  • Read

    Gets a single rule group in Prometheus-compatible format if it was imported from a Prometheus-compatible source.

    GET /convert/api/prom/rules/{NamespaceTitle}/{Group}

  • Read

    Gets all Grafana-managed alert rules that were imported from Prometheus-compatible sources, grouped by namespace.

    GET /convert/prometheus/config/v1/rules

  • Read

    Gets Grafana-managed alert rules that were imported from Prometheus-compatible sources for a specified namespace (folde…

    Gets Grafana-managed alert rules that were imported from Prometheus-compatible sources for a specified namespace (folder).

  • Read

    Gets a single rule group in Prometheus-compatible format if it was imported from a Prometheus-compatible source.

    GET /convert/prometheus/config/v1/rules/{NamespaceTitle}/{Group}

  • Write

    Converts the submitted rule groups into Grafana-Managed Rules.

    POST /convert/api/prom/rules

  • Write

    Converts a Prometheus rule group into a Grafana rule group and creates or updates it within the specified namespace.

    If the group already exists and was not imported from a Prometheus-compatible source initially, it will not be replaced and an error will be returned.

  • Write

    Converts the submitted rule groups into Grafana-Managed Rules.

    POST /convert/prometheus/config/v1/rules

  • Write

    Converts a Prometheus rule group into a Grafana rule group and creates or updates it within the specified namespace.

    If the group already exists and was not imported from a Prometheus-compatible source initially, it will not be replaced and an error will be returned.

  • Destructive

    Deletes all rule groups that were imported from Prometheus-compatible sources within the specified namespace.

    DELETE /convert/api/prom/rules/{NamespaceTitle}

  • Destructive

    Deletes a specific rule group if it was imported from a Prometheus-compatible source.

    DELETE /convert/api/prom/rules/{NamespaceTitle}/{Group}

  • Destructive

    Deletes all rule groups that were imported from Prometheus-compatible sources within the specified namespace.

    DELETE /convert/prometheus/config/v1/rules/{NamespaceTitle}

  • Destructive

    Deletes a specific rule group if it was imported from a Prometheus-compatible source.

    DELETE /convert/prometheus/config/v1/rules/{NamespaceTitle}/{Group}

Dashboards

  • Read

    List snapshots.

    GET /dashboard/snapshots

  • Read

    List Public Dashboards

    Get list of public dashboards

  • Read

    Get Public Dashboard

    Get public dashboard by dashboardUid

  • Read

    View Public Dashboard

    Get public dashboard for view

  • Read

    Get Public Annotations

    Get annotations for a public dashboard

  • Read

    Query Public Dashboard

    Get results for a given panel on a public dashboard

  • Read

    Get Snapshot by Key.

    GET /snapshots/{key}

  • Write

    Import dashboard.

    POST /dashboards/import

  • Write

    Interpolate dashboard. This is an experimental endpoint under dashboardLibrary or suggestedDashboards feature flags and…

    Interpolate dashboard. This is an experimental endpoint under dashboardLibrary or suggestedDashboards feature flags and is subject to change.

  • Write

    Create Public Dashboard

    Create public dashboard for a dashboard

  • Write

    Update Public Dashboard

    Update public dashboard for a dashboard

  • Write

    When creating a snapshot using the API, you have to provide the full dashboard payload including the snapshot data.

    Snapshot public mode should be enabled or authentication is required.

  • Destructive

    Delete Public Dashboard

    Delete public dashboard for a dashboard

  • Destructive

    Delete Snapshot by deleteKey.

    Snapshot public mode should be enabled or authentication is required.

    GET /snapshots-delete/{deleteKey}

  • Destructive

    Delete Snapshot by Key.

    DELETE /snapshots/{key}

Datasources

  • Read

    Get all data sources.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: datasources:read and scope: datasources:.

  • Read

    Gets all correlations.

    GET /datasources/correlations

  • Read

    Data source proxy GET calls.

    Proxies all calls to the actual data source.

  • Read

    Gets all correlations originating from the given data source.

    GET /datasources/uid/{sourceUID}/correlations

  • Read

    Gets a correlation.

    GET /datasources/uid/{sourceUID}/correlations/{correlationUID}

  • Read

    Get a single data source by UID.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: datasources:read and scopes: datasources:, datasources:uid: and datasources:uid:kLtEtcRGk (single data source).

  • Read

    Sends a health check request to the plugin datasource identified by the UID.

    GET /datasources/uid/{uid}/health

  • Read

    Fetch data source resources.

    GET /datasources/uid/{uid}/resources/{datasource_proxy_route}

  • Write

    Create a data source.

    By defining password and basicAuthPassword under secureJsonData property Grafana encrypts them securely as an encrypted blob in the database. The response then lists the encrypted fields under secureJsonFields.

  • Write

    Data source proxy POST calls.

    Proxies all calls to the actual data source. The data source should support POST methods for the specific path and role as defined

  • Write

    Add correlation.

    POST /datasources/uid/{sourceUID}/correlations

  • Write

    Updates a correlation.

    PATCH /datasources/uid/{sourceUID}/correlations/{correlationUID}

  • Write

    DataSource query metrics with expressions.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: datasources:query.

  • Destructive

    Data source proxy DELETE calls.

    Proxies all calls to the actual data source.

  • Destructive

    Update an existing data source.

    Similar to creating a data source, password and basicAuthPassword should be defined under secureJsonData in order to be stored securely as an encrypted blob in the database. Then, the encrypted fields are listed under secureJsonFields section in the response.

  • Destructive

    Delete an existing data source by UID.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: datasources:delete and scopes: datasources:, datasources:uid: and datasources:uid:kLtEtcRGk (single data source).

  • Destructive

    Delete a correlation.

    DELETE /datasources/uid/{uid}/correlations/{correlationUID}

Enterprise

  • Read

    Retrieves LBAC rules for a team.

    GET /datasources/uid/{uid}/lbac/teams

  • Read

    Get Data Source Cache Config

    get cache config for a single data source

  • Write

    Set Data Source Cache Config

    set cache config for a single data source

  • Write

    Clean Data Source Cache

    clean cache for a single data source

  • Write

    Disable Data Source Cache

    disable cache for a single data source

  • Write

    Enable Data Source Cache

    enable cache for a single data source

  • Destructive

    Updates LBAC rules for a team.

    PUT /datasources/uid/{uid}/lbac/teams

Folders

  • Write

    Updates permissions for a folder. This operation will remove existing permissions if they’re not included in the reques…

    Updates permissions for a folder. This operation will remove existing permissions if they’re not included in the request.

Health

  • Read

    Get Health

    apiHealthHandler will return ok if Grafana's web server is running and it can access the database. If the database cannot be accessed it will return http status code 503.

Library elements

  • Read

    Get all library elements.

    Returns a list of all library elements the authenticated user has permission to view. Use the perPage query parameter to control the maximum number of library elements returned; the default limit is 100.

  • Read

    Get library element by name.

    Returns a library element with the given name.

  • Read

    Get library element by UID.

    Returns a library element with the given UID.

  • Read

    Get library element connections.

    Returns a list of connections for a library element based on the UID specified.

  • Write

    Create library element.

    Creates a new library element.

  • Write

    Update library element.

    Updates an existing library element identified by uid.

  • Destructive

    Delete library element.

    Deletes an existing library element as specified by the UID. This operation cannot be reverted. You cannot delete a library element that is connected. This operation cannot be reverted.

Licensing

  • Read

    Check license availability.

    GET /licensing/check

  • Read

    Refresh license stats.

    You need to have a permission with action licensing:read.

  • Read

    Get license token.

    You need to have a permission with action licensing:read.

  • Write

    Create license token.

    You need to have a permission with action licensing:write.

  • Write

    Manually force license refresh.

    Manually ask license issuer for a new token. Available in Grafana Enterprise v7.4+. You need to have a permission with action licensing:write.

  • Destructive

    Remove license from database.

    Removes the license stored in the Grafana database. Available in Grafana Enterprise v7.4+. You need to have a permission with action licensing:delete.

Saml

  • Read

    GetLogout initiates single logout process.

    GET /logout/saml

  • Read

    It exposes the SP (Grafana's) metadata for the IdP's consumption.

    GET /saml/metadata

  • Read

    It performs Single Logout (SLO) callback.

    There might be two possible requests: 1. Logout response (callback) when Grafana initiates single logout and IdP returns response to logout request. 2.

  • Write

    It performs Assertion Consumer Service (ACS).

    POST /saml/acs

  • Write

    It performs Single Logout (SLO) callback.

    There might be two possible requests: 1. Logout response (callback) when Grafana initiates single logout and IdP returns response to logout request. 2.

Org

  • Read

    Get current Organization.

    GET /org

  • Read

    Get pending invites.

    GET /org/invites

  • Read

    Get all users within the current organization.

    Returns all org users within the current organization. Accessible to users with org admin role. If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:read with scope users:.

  • Read

    Get all users within the current organization (lookup)

    Returns all org users within the current organization, but with less detailed information. Accessible to users with org admin role, admin in any folder or admin of any team.

  • Write

    Add invite.

    POST /org/invites

  • Write

    Add a new user to the current organization.

    Adds a global user to the current organization. If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:add with scope users:.

  • Write

    Updates the given user.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users.role:update with scope users:.

  • Destructive

    Update current Organization.

    PUT /org

  • Destructive

    Update current Organization's address.

    PUT /org/address

  • Destructive

    Revoke invite.

    DELETE /org/invites/{invitation_code}/revoke

  • Destructive

    Delete user in current organization.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:remove with scope users:.

Orgs

  • Read

    Search all Organizations.

    GET /orgs

  • Read

    Get Organization by Name.

    GET /orgs/name/{org_name}

  • Read

    Get Organization by ID.

    GET /orgs/{org_id}

  • Read

    Get Users in Organization.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:read with scope users:.

  • Read

    Search Users in Organization.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:read with scope users:.

  • Write

    Create Organization.

    Only works if users.alloworgcreate is set.

  • Write

    Add a new user to the current organization.

    Adds a global user to the current organization. If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:add with scope users:.

  • Write

    Update Users in Organization.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users.role:update with scope users:.

  • Destructive

    Update Organization.

    PUT /orgs/{org_id}

  • Destructive

    Delete Organization.

    DELETE /orgs/{org_id}

  • Destructive

    Update Organization's address.

    PUT /orgs/{org_id}/address

  • Destructive

    Delete user in current organization.

    If you are running Grafana Enterprise and have Fine-grained access control enabled you need to have a permission with action: org.users:remove with scope users:.

Query history

  • Read

    Query history search.

    Returns a list of queries in the query history that matches the search criteria. Query history search supports pagination. Use the limit parameter to control the maximum number of queries returned; the default limit is 100.

  • Write

    Add query to query history.

    Adds new query to query history.

  • Write

    Add star to query in query history.

    Adds star to query in query history as specified by the UID.

  • Write

    Update comment for query in query history.

    Updates comment for query in query history as specified by the UID.

  • Destructive

    Remove star to query in query history.

    Removes star from query in query history as specified by the UID.

  • Destructive

    Delete query in query history.

    Deletes an existing query in query history as specified by the UID. This operation cannot be reverted.

Recording rules

  • Read

    Lists all rules in the database: active or deleted.

    GET /recording-rules

  • Read

    Return the prometheus remote write target.

    GET /recording-rules/writer

  • Write

    Create a recording rule that is then registered and started.

    POST /recording-rules

  • Write

    Test a recording rule.

    POST /recording-rules/test

  • Write

    Create a remote write target.

    It returns a 422 if there is not an existing prometheus data source configured.

  • Destructive

    Update the active status of a rule.

    PUT /recording-rules

  • Destructive

    Delete the remote write target.

    DELETE /recording-rules/writer

  • Destructive

    Delete removes the rule from the registry and stops it.

    DELETE /recording-rules/{recordingRuleID}

Reports

  • Read

    List reports.

    Available to org admins only and with a valid or expired license. You need to have a permission with action reports:read with scope reports:.

  • Read

    List reports by dashboard uid.

    Available to org admins only and with a valid or expired license. You need to have a permission with action reports:read with scope reports:.

  • Read

    Get custom branding report image.

    Available to org admins only and with a valid or expired license. You need to have a permission with action reports.settings:read.

  • Read

    Download a CSV report.

    Available to all users and with a valid license.

  • Read

    Render report for multiple dashboards.

    Available to all users and with a valid license.

  • Read

    Get report settings.

    Available to org admins only and with a valid or expired license. You need to have a permission with action reports.settings:readx.

  • Write

    Create a report.

    Available to org admins only and with a valid license. You need to have a permission with action reports.admin:create.

  • Write

    Send a report.

    Generate and send a report. This API waits for the report to be generated before returning. We recommend that you set the client’s timeout to at least 60 seconds. Available to org admins only and with a valid license. Only available in Grafana Enterprise v7.0+.

  • Write

    Save settings.

    Available to org admins only and with a valid or expired license. You need to have a permission with action reports.settings:writexx.

  • Write

    Send test report via email.

    Available to org admins only and with a valid license. You need to have a permission with action reports:send.

Search

  • Read

    List search sorting options.

    GET /search/sorting

Service accounts

  • Read

    Search service accounts with paging

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:read scope: serviceaccounts:

  • Read

    Get single serviceaccount by Id

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:read scope: serviceaccounts:id:1 (single service account)

  • Read

    Get service account tokens

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:read scope: global:serviceaccounts:id:1 (single service account) Requires basic authentication and that the authenticated user is a Grafana Admin.

  • Write

    Create service account

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:write scope: serviceaccounts: Requires basic authentication and that the authenticated user is a Grafana Admin.

  • Write

    Update service account

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:write scope: serviceaccounts:id:1 (single service account)

  • Write

    CreateNewToken adds a token to a service account

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:write scope: serviceaccounts:id:1 (single service account)

  • Destructive

    Delete service account

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:delete scope: serviceaccounts:id:1 (single service account)

  • Destructive

    DeleteToken deletes service account tokens

    Required permissions (See note in the introduction for an explanation): action: serviceaccounts:write scope: serviceaccounts:id:1 (single service account) Requires basic authentication and that the authenticated user is a Grafana Admin.

Signing keys

  • Read

    Get JSON Web Key Set (JWKS) with all the keys that can be used to verify tokens (public keys)

    Required permissions None

Snapshots

  • Read

    Get snapshot sharing settings.

    GET /snapshot/shared-options

Teams

  • Read

    Team Search With Paging.

    GET /teams/search

  • Read

    Get Team By ID.

    GET /teams/{team_id}

  • Read

    Get Team Members.

    GET /teams/{team_id}/members

  • Read

    Get Team Preferences.

    GET /teams/{team_id}/preferences

  • Write

    Add Team.

    POST /teams

  • Write

    Add Team Member.

    POST /teams/{team_id}/members

  • Destructive

    Update Team.

    PUT /teams/{team_id}

  • Destructive

    Delete Team By ID.

    DELETE /teams/{team_id}

  • Destructive

    Set team memberships.

    Takes user emails, and updates team members and admins to the provided lists of users. Any current team members and admins not in the provided lists will be removed.

  • Destructive

    Update Team Member.

    PUT /teams/{team_id}/members/{user_id}

  • Destructive

    Remove Member From Team.

    DELETE /teams/{team_id}/members/{user_id}

  • Destructive

    Update Team Preferences.

    PUT /teams/{team_id}/preferences

Sync team groups

  • Read

    Get External Groups.

    GET /teams/{teamId}/groups

  • Read

    Search for team groups with optional filtering and pagination.

    GET /teams/{teamId}/groups/search

  • Write

    Add External Group.

    POST /teams/{teamId}/groups

  • Destructive

    Remove External Group.

    DELETE /teams/{teamId}/groups

Signed in user

  • Read

    Get Signed In User

    Get (current authenticated user)

  • Read

    Auth tokens of the actual User.

    Return a list of all auth tokens (devices) that the actual user currently have logged in from.

  • Read

    Organizations of the actual User.

    Return a list of all organizations of the current user.

  • Read

    Teams that the actual User is member of.

    Return a list of all teams that the current user is member of.

  • Write

    Switch user context for signed in user.

    Switch user context to the given organization.

  • Destructive

    Update signed in User.

    PUT /user

  • Destructive

    Change Password.

    Changes the password for the user.

  • Destructive

    Revoke an auth token of the actual User.

    Revokes the given auth token (device) for the actual user. User of issued auth token (device) will no longer be logged in and will be required to authenticate again upon next activity.

User

  • Write

    Update user email.

    Update the email of user given a verification code.

    GET /user/email/update

Users

  • Read

    Get users.

    Returns all users that the authenticated user has permission to view, admin permission required.

  • Read

    Get user by login or email.

    GET /users/lookup

  • Read

    Get users with paging.

    GET /users/search

  • Read

    Get user by id.

    GET /users/{user_id}

  • Read

    Get organizations for user.

    Get organizations for user identified by id.

  • Read

    Get teams for user.

    Get teams for user identified by id.

  • Destructive

    Update user.

    Update the user identified by id.

Provisioning

  • Read

    Export all alert rules in provisioning file format.

    GET /v1/provisioning/alert-rules/export

  • Read

    Export an alert rule in provisioning file format.

    GET /v1/provisioning/alert-rules/{UID}/export

  • Read

    Export all contact points in provisioning file format.

    GET /v1/provisioning/contact-points/export

  • Read

    Export an alert rule group in provisioning file format.

    GET /v1/provisioning/folder/{FolderUID}/rule-groups/{Group}/export

  • Read

    Export all mute timings in provisioning format.

    GET /v1/provisioning/mute-timings/export

  • Read

    Export a mute timing in provisioning format.

    GET /v1/provisioning/mute-timings/{name}/export

  • Read

    Export the notification policy tree in provisioning file format.

    GET /v1/provisioning/policies/export

Sso settings

  • Read

    List all SSO Settings entries

    You need to have a permission with action settings:read with scope settings:auth. :.

  • Read

    Get an SSO Settings entry by Key

    You need to have a permission with action settings:read with scope settings:auth. :.

  • Write

    Patch SSO Settings

    Partially updates the SSO Settings for a provider. Only provided fields are updated. You need to have a permission with action settings:write and scope settings:auth. :.

  • Destructive

    Update SSO Settings

    Inserts or updates the SSO Settings for a provider. You need to have a permission with action settings:write and scope settings:auth. :.

  • Destructive

    Remove SSO Settings

    Removes the SSO Settings for a provider. You need to have a permission with action settings:write and scope settings:auth. :.

See How connections work for access and permissions, or browse all integrations.